You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 

356 lines
17 KiB

  1. #!/usr/bin/env sh
  2. command -V gpg >/dev/null 2>&1 && GPG="gpg" || GPG="gpg2"
  3. [ -z ${PASSWORD_STORE_DIR+x} ] && PASSWORD_STORE_DIR="$HOME/.password-store"
  4. [ -r "$PASSWORD_STORE_DIR/.gpg-id" ] &&
  5. "$GPG" --list-secret-keys $(cat "$PASSWORD_STORE_DIR/.gpg-id") >/dev/null 2>&1 || {
  6. printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`$GPG --full-gen-key\` first.\\n"
  7. exit
  8. }
  9. ! command -v mbsync >/dev/null && printf "\`mbsync\` must be installed to run mutt-wizard.\\n" && exit
  10. prefix="/usr/local"
  11. muttdir="$HOME/.config/mutt" # Main mutt config location
  12. accdir="$muttdir/accounts" # Directory for account settings
  13. maildir="$HOME/.local/share/mail" # Location of mail storage
  14. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  15. emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
  16. muttshare="$prefix/share/mutt-wizard"
  17. mbsyncrc="$HOME/.mbsyncrc"
  18. mwconfig="$muttshare/mutt-wizard.muttrc"
  19. cachedir="$HOME/.cache/mutt-wizard"
  20. muttrc="$muttdir/muttrc"
  21. msmtprc="$HOME/.config/msmtp/config"
  22. ssltype="IMAPS" # This is later changed to `None` later in the script if using Protonmail
  23. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem" "/etc/ssl/cert.pem" "/usr/local/share/ca-certificates/"
  24. do
  25. [ -f "$x" ] && sslcert="$x" && break
  26. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  27. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\..*//" | sort -n)" ;}
  28. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  29. getprofiles() { \
  30. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  31. printf "Creating profiles for \`%s\`..." "$title"
  32. msmtp_header="defaults
  33. auth on
  34. tls on
  35. tls_trust_file $sslcert
  36. logfile ~/.config/msmtp/msmtp.log
  37. "
  38. msmtp_profile="account $title
  39. host $smtp
  40. port $sport
  41. from $fulladdr
  42. user $login
  43. passwordeval \"pass mutt-wizard-$title\"
  44. $starttlsoff
  45. "
  46. mbsync_profile="IMAPStore $title-remote
  47. Host $imap
  48. Port $iport
  49. User $login
  50. PassCmd \"pass mutt-wizard-$title\"
  51. SSLType $ssltype
  52. CertificateFile $sslcert
  53. MaildirStore $title-local
  54. Subfolders Verbatim
  55. Path ~/.local/share/mail/$title/
  56. Inbox ~/.local/share/mail/$title/INBOX
  57. Flatten .
  58. Channel $title
  59. Expunge Both
  60. Master :$title-remote:
  61. Slave :$title-local:
  62. Patterns * !\"[Gmail]/All Mail\"
  63. Create Both
  64. SyncState *
  65. MaxMessages $maxmes
  66. ExpireUnread no
  67. # End profile
  68. "
  69. if [ "$accounttype" = "offline" ]; then
  70. mutt_profile="# vim: filetype=neomuttrc
  71. # muttrc file for account $title
  72. set realname = \"$realname\"
  73. set from = \"$fulladdr\"
  74. set sendmail = \"msmtp -a $title\"
  75. alias me $realname <$fulladdr>
  76. set folder = \"$maildir/$title\"
  77. set header_cache = $cachedir/$title/headers
  78. set message_cachedir = $cachedir/$title/bodies
  79. set mbox_type = Maildir
  80. bind index,pager gg noop
  81. bind index,pager g noop
  82. bind index,pager M noop
  83. bind index,pager C noop
  84. bind index gg first-entry
  85. macro index o \"<shell-escape>mailsync -V $title<enter>\" \"run mbsync to sync $title\"
  86. unmailboxes *
  87. "
  88. else
  89. mutt_profile="# vim: filetype=neomuttrc
  90. # muttrc file for account $title
  91. set realname = \"$realname\"
  92. set from = \"$fulladdr\"
  93. set sendmail = \"$prefix/bin/msmtp -a $title\"
  94. alias me $realname <$fulladdr>
  95. set folder = \"imaps://$fulladdr@$imap:$iport\"
  96. set imap_user = \"$login\"
  97. set header_cache = $cachedir/$title/headers
  98. set message_cachedir = $cachedir/$title/bodies
  99. set imap_pass = \"\`pass mutt-wizard-$title\`\"
  100. set mbox_type = Maildir
  101. set ssl_starttls = yes
  102. set ssl_force_tls = yes
  103. bind index,pager gg noop
  104. bind index,pager g noop
  105. bind index,pager M noop
  106. bind index,pager C noop
  107. bind index gg first-entry
  108. unmailboxes *
  109. "
  110. fi
  111. printf "DONE.\\n"
  112. }
  113. askinfo() { \
  114. printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
  115. read -r fulladdr
  116. printf "\033[0m"
  117. while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
  118. printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
  119. read -r fulladdr
  120. printf "\033[0m"
  121. done
  122. domain="$(echo "$fulladdr" | sed "s/.*@//")"
  123. search_query=$domain
  124. case "$domain" in
  125. protonmail.com|protonmail.ch|pm.me)
  126. search_query='protonmail.com' && break;;
  127. *)
  128. while : ; do
  129. printf "\nIs your email hosted with Protonmail? [yes/no] "
  130. read -r is_protonmail
  131. case $is_protonmail in
  132. [Yy][Ee][Ss]) search_query='protonmail.com' && break;;
  133. [Nn][Oo]) break;;
  134. *) printf 'Please answer Yes or No'
  135. esac; done;
  136. esac
  137. printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
  138. serverinfo="$(grep "^$search_query" "$muttshare/domains.csv" 2>/dev/null)"
  139. if [ -z "$serverinfo" ]; then
  140. printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
  141. printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
  142. read -r imap
  143. printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
  144. read -r iport
  145. printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
  146. read -r smtp
  147. printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
  148. read -r sport
  149. printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
  150. else
  151. IFS=, read -r service imap iport smtp sport <<EOF
  152. $serverinfo
  153. EOF
  154. printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically been found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
  155. case "$service" in
  156. gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
  157. protonmail.ch|protonmail.com|pm.me) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" && ssltype="None" ;;
  158. esac
  159. [ "$sport" = 465 ] && starttlsoff="tls_starttls off"
  160. fi
  161. printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
  162. read -r realname
  163. printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
  164. read -r title
  165. while ! echo "$title" | grep "$namere" >/dev/null || ls "$accdir"/[0-9]"-$title.muttrc" >/dev/null 2>&1; do
  166. printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or - and that you have \033[1mnot\033[0m used before.\\n\tAccount name: \033[36m\t"
  167. read -r title
  168. printf "\033[0m"
  169. done
  170. printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
  171. read -r login
  172. printf "\033[0m"
  173. [ -z "$login" ] && login="$fulladdr"
  174. [ "$accounttype" = "offline" ] && printf "If you want to limit the number of messages kept offline to a number, enter that number below. If you do not want to limit your mail and would like \`mbsync\` to sync all mail, press enter without typing a number.\\n\t" && read -r maxmes
  175. echo "$maxmes" | grep "[1-9]" >/dev/null || maxmes="0"
  176. getpass
  177. getprofiles
  178. mkdir -p "$muttdir" "$accdir" "$cachedir/$title/bodies" "$HOME/.config/msmtp"
  179. getaccounts
  180. for x in $(seq 1 9); do echo "$accounts" | grep "$x" >/dev/null 2>&1 || { export idnum="$x"; break ;}; done
  181. [ ! -f "$msmtprc" ] && echo "$msmtp_header" > "$msmtprc"
  182. echo "$msmtp_profile" >> "$msmtprc"
  183. command -V apt-get >/dev/null 2>&1 && ln -s "$msmtprc" "$HOME/.msmtprc" 2>/dev/null
  184. case "$service" in
  185. protonmail.ch|protonmail.com|pm.me) protonfinger || return 1 ;;
  186. esac
  187. echo "$mutt_profile" > "$accdir/$idnum-$title.muttrc"
  188. echo "$mbsync_profile" >> "$mbsyncrc"
  189. notmuchauto
  190. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc" && echo "muttrc created."
  191. ! grep "^source.*mutt-wizard.muttrc" "$muttrc" >/dev/null && echo "source $mwconfig # mw-autogenerated" >> "$muttrc"
  192. ! grep "^source.*.muttrc" "$muttrc" | grep -v "$mwconfig" >/dev/null && echo "source $accdir/$idnum-$title.muttrc # mw-autogenerated" >> "$muttrc"
  193. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" # mw-autogenerated" >> "$muttrc"
  194. }
  195. protonfinger() { printf "Getting Protonmail bridge fingerprint...\\n"
  196. fingerprint="$(msmtp --serverinfo --host=127.0.0.1 --port=1025 --tls --tls-certcheck=off | grep SHA256: | sed 's/^.*: //')"
  197. sed -ibu "s/account $title/&\ntls_trust_file\ntls_fingerprint $fingerprint/" "$msmtprc" ; rm -f "$msmtprc"bu
  198. }
  199. getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
  200. pass insert "mutt-wizard-$title" && break; done ;}
  201. formatShortcut() { \
  202. while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # mw-autogenerated"
  203. echo "macro index,pager M$1 \";<save-message>$data<enter>\" \"move mail to $2\" # mw-autogenerated"
  204. echo "macro index,pager C$1 \";<copy-message>$data<enter>\" \"copy mail to $2\" # mw-autogenerated"; } >> "$accdir/$idnum-$title.muttrc"
  205. done ;}
  206. tryconnect() { mkdir -p "$maildir/$title"
  207. if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  208. [ "$accounttype" = "online" ] && sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -f "$mbsyncrc"bu
  209. printf "\033[32mMailboxes detected.\033[0m\\n"
  210. echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
  211. return 0
  212. else
  213. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  214. return 1
  215. fi ;}
  216. finalize() { \
  217. boxes="$(find "$maildir/$title/" -mindepth 1 -maxdepth 1 | sed "s/\ /\\\ /g;s/^.*\//=/")"
  218. [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
  219. printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
  220. spoolfile=$(echo "$boxes" | grep -i -m 1 inbox | sed 's/=/+/g')
  221. record=$(echo "$boxes" | grep -i -m 1 sent | sed 's/=/+/g')
  222. postponed=$(echo "$boxes" | grep -i -m 1 draft | sed 's/=/+/g')
  223. trash=$(echo "$boxes" | grep -i -m 1 trash | sed 's/=/+/g')
  224. sed -ibu "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  225. { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$idnum-$title.muttrc"
  226. echo "mailboxes $(echo "$boxes" | sed -e "s/^\|$/\"/g" | tr "\n" " ")" >> "$accdir/$idnum-$title.muttrc"
  227. printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
  228. sed -ibu "/# mw-autogenerated/d" "$accdir/$idnum-$title.muttrc" ; rm -f "$accdir/$idnum-$title.muttrcbu"
  229. echo "$boxes" | grep -i inbox | head -n 1 | formatShortcut i inbox
  230. echo "$boxes" | grep -i sent | head -n 1 | formatShortcut s sent
  231. echo "$boxes" | grep -i draft | head -n 1 | formatShortcut d drafts
  232. echo "$boxes" | grep -i trash | head -n 1 | formatShortcut t trash
  233. echo "$boxes" | grep -i spam | head -n 1 | formatShortcut S spam
  234. echo "$boxes" | grep -i junk | head -n 1 | formatShortcut j junk
  235. echo "$boxes" | grep -i archive | head -n 1 | formatShortcut a archive
  236. [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
  237. command -V urlview >/dev/null 2>&1 && [ ! -f "$HOME/.urlview" ] && echo "COMMAND \$BROWSER" > "$HOME/.urlview"
  238. return 0
  239. }
  240. confirm() { printf "Do you want to %s? [y/N]\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  241. printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  242. return 0 ;}
  243. pick() { printf "Select an accounts to %s:\\n" "$1"
  244. list
  245. read -r input
  246. [ -z "$input" ] && return 1
  247. title="$(echo "$accounts" | grep "$input" | awk '{print $2}')"
  248. [ -z "$title" ] && printf "Invalid response." && return 1
  249. return 0 ;}
  250. delete() { sed -ibu "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc" ; rm -rf "$mbsyncrc"bu
  251. rm -rf "${cachedir:?}/${title:?}" "$accdir/"[1-9]"-$title.muttrc"
  252. sed -ibu "/[0-9]-$title.muttrc/d" "$muttrc" ; rm -f "$muttrc"bu
  253. sed -ibu "/account $title/,/^\(\s*$\|account\)/d" "$msmtprc"; rm -f "$msmtprc"bu
  254. }
  255. choosecron() { ! pgrep cron >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
  256. if crontab -l | grep mailsync >/dev/null; then
  257. echo "Active mail sync cronjob detected. Do you want to remove it?"
  258. printf "\033[36m\t"
  259. read -r rmyn
  260. printf "\033[0m"
  261. echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
  262. else
  263. echo "How many minutes between each mail sync?"
  264. printf "\033[36m\t"
  265. read -r minnum
  266. printf "\033[0m"
  267. while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
  268. printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
  269. read -r minnum
  270. printf "\033[0m"
  271. done
  272. (crontab -l; echo "*/$minnum * * * * export DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/$(id -u)/bus; export DISPLAY=:0; . \$HOME/.profile; $(type mailsync | cut -d' ' -f3)") | crontab - &&
  273. echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
  274. fi ;}
  275. asktype() { while : ; do
  276. printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
  277. read -r offnot
  278. case "$offnot" in
  279. [Yy][Ee][Ss]) accounttype="offline" && break ;;
  280. [Nn][Oo]) accounttype="online" && break ;;
  281. *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
  282. esac; done ;}
  283. purge() { confirm "delete all account data" || exit
  284. rm -rf "$mbsyncrc" "$accdir" "$HOME/.config/msmtp" "$cachedir"
  285. crontab -l | sed '/mailsync/d' | crontab - >/dev/null
  286. echo "All configs and account settings have been purged."
  287. sed -ibu "/\# mw-autogenerated/d" "$muttrc" ; rm -f "$muttrc"bu
  288. }
  289. notmuchauto() { \
  290. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  291. [ -f "$NOTMUCH_CONFIG" ] && return 0
  292. nmbasic="[database]
  293. path=$maildir
  294. [user]
  295. name=$realname
  296. primary_email=$fulladdr
  297. [new]
  298. tags=unread;inbox;
  299. ignore=
  300. [search]
  301. exclude_tags=deleted;spam;
  302. [maildir]
  303. synchronize_flags=true
  304. [crypto]
  305. gpg_path=$GPG"
  306. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  307. trap 'echo -e "\033[0m\n"; exit' STOP INT ABRT KILL
  308. case "$1" in
  309. ls) list ;;
  310. add) asktype && askinfo && tryconnect && finalize || delete ;;
  311. pass) pick "change the password of" && getpass ;;
  312. delete) pick delete && confirm "delete the \`$title\` profile" && delete ;;
  313. purge) purge ;;
  314. cron) choosecron ;;
  315. *) cat << EOF
  316. mw: mutt-wizard, auto-configure email accounts for mutt
  317. including downloadable mail with \`isync\`.
  318. Allowed options:
  319. add Add and autoconfigure an email address (9 max.)
  320. ls List configured accounts
  321. delete Pick an account to delete
  322. purge Delete all accounts and settings
  323. cron Enable or disable an autosync via cronjob
  324. all else Print this message
  325. NOTE: Once at least one account is added, you can run
  326. \`mbsync -a\` to begin downloading mail.
  327. EOF
  328. esac